#!/bin/bash
# MediaWiki	(http://www.mediawiki.org/wiki/MediaWiki)
#	BuildScript for Plamo Linux 4.22
#			by Jun Kuwamura <juk@linet.gr.jp> on 2008-07-16
# require:
# require:
#	httpd-2.2.x
#	php-5.2.x
#	postgresql-8.3.x
#	textsearch_ja-8.3.x
#	mecab-0.97, ipadic-0.9.2
#
VERSION=1.11.2
M_VER=${VERSION%%\.?}
#echo $M_VER
SRC_URI="http://download.wikimedia.org/mediawiki/$M_VER/mediawiki-${VERSION}.tar.gz"
SRC_FILE=${SRC_URI##*/}
PAC_NAME=${SRC_FILE%%.tar.gz}

REL=P1
CPU=noname
SYS_NAME="${CPU}-${REL}"

PLAMO=/expo/Build
SRC_DIR=$PLAMO/Archive/www/php/appli
PAC_DIR=$PLAMO/Packages/4.5/WWW/PHPAppli
BUILD_DIR=$PLAMO/mediawiki
CUSTOM_DIR=$BUILD_DIR/Custom
PAT_FILE=mediawiki-1.11.1-PGSQL8.3.patch

JPO_URI=
JPO_FILE=${JPO_URI##*/}

echo $PAC_DIR
if [ ! -d $PAC_DIR ]; then
  mkdir -p  $PAC_DIR
fi
echo $SRC_DIR/$SRC_FILE
if [ ! -f $SRC_DIR/$SRC_FILE ]; then
  if [ ! -d $SRC_DIR ]; then
    mkdir -p $SRC_DIR
  fi
  ( cd $SRC_DIR; wget $SRC_URI )
fi


umask 022
CWD=`pwd`
WORK=$CWD/work
rm -rf $WORK/*
mkdir -p $WORK
export LANG=C
export LC_ALL=C
export CFLAGS="-O2 -march=$CPU"
export PATH=$PATH:/usr/X11R7/bin


cd $WORK

mkdir -p install
sed -e "s/VERSION/$VERSION/g" $CUSTOM_DIR/doinst.sh > install/doinst.sh

mkdir -p opt/htdocs
cd opt/htdocs
# cd to application directory
tar xvfz $SRC_DIR/$SRC_FILE
cd $PAC_NAME

sed -e 's/wikiuser/www/' config/index.php > config/index.php.bak || exit 1
mv -v  config/index.php.bak  config/index.php

if ! [ -f $CUSTOM_DIR/mediawiki-${VERSION}-docs_html.tgz ]; then
  export PATH=/opt/php5/bin:$PATH
  echo "0" | php maintenance/mwdocgen.php 
  tar cvfz  $CUSTOM_DIR/mediawiki-${VERSION}-docs_html.tgz docs/html
  rm -rf docs/html/
fi

#
# apply or add patches
#
if [ -f $CUSTOM_DIR/$PAT_FILE ]; then
  patch -p1 < $CUSTOM_DIR/$PAT_FILE
fi
## http://svn.wikimedia.org/viewvc/mediawiki/trunk/phase3/maintenance/postgres/archives/patch-tsearch2funcs.sql
#cp  -v  $CUSTOM_DIR/patch-tsearch2funcs.sql \
#  maintenance/postgres/archives/patch-tsearch2funcs.sql


# remove unnessasery wrappers
find . -name "*.php5" -o -name "*.phtml" | xargs rm -f

cp -a $CUSTOM_DIR/custom/  ./
chown -R root:apache  ./


DOC_DIR=usr/share/doc/$PAC_NAME
mkdir -p $WORK/$DOC_DIR || exit 1
cp -p $BUILD_DIR/`basename $0`  \
  $WORK/$DOC_DIR/
mv -v  [A-Z][A-Z]*  docs/ \
    $WORK/$DOC_DIR
chown -R root.root $WORK/$DOC_DIR
chmod -R a+rX,go-w $WORK/$DOC_DIR


mkdir -p $WORK/opt/htdocs/AppList || exit 1
TYP=2 #(0:httpd, 1:libraries, 2:application)
cat >> $WORK/opt/htdocs/AppList/${TYP}.${PAC_NAME}.list <<__EOCL__
TYP	$TYP
NAM	${PAC_NAME}
URL	http://www.mediawiki.org/wiki/MediaWiki
DOC	/${DOC_DIR}/
EXE	/mediawiki/
REM	wiki package originally written for Wikipedia
__EOCL__


cd $WORK
echo "y
1
" | makepkg ${PAC_NAME}.tgz

echo -n "$PAC_DIR/${PAC_NAME}-${SYS_NAME}.tgz"
if `mv -v ${PAC_NAME}.tgz  $PAC_DIR/${PAC_NAME}-${SYS_NAME}.tgz 1>/dev/null 2>&1`; then
  echo " ... done"
else
  echo " ... false"
fi

if ! [ -f $PAC_DIR/mediawiki_doc_html-${VERSION}-${SYS_NAME}.tgz ]; then
  tar xfz  $CUSTOM_DIR/mediawiki-${VERSION}-docs_html.tgz -C $DOC_DIR
  tar cvfz  $PAC_DIR/mediawiki_doc_html-${VERSION}-${SYS_NAME}.tgz \
	$DOC_DIR/docs/html/
fi

cd $CWD
